<template>
  <div id="book-table">
    <p
      v-if="books.length < 1"
      class="empty-table"
    >
      No Books
    </p>
    <table v-else>
      <thead>
        <tr>
          <th>Name</th>
          <th>Author</th>
          <th>Price</th>
          <th>Actions</th>
        </tr>
      </thead>
      <tbody>
        <tr
          :key="book.id"
          v-for="book in books"
        >
          <td v-if="editing === book.id">
            <input
              type="text"
              v-model="book.name"
            >
          </td>
          <td v-else>{{book.name}}</td>


          <td v-if="editing === book.id">
            <input
              type="text"
              v-model="book.author"
            >
          </td>
          <td v-else>{{book.author}}</td>

          <td v-if="editing === book.id">
            <input
              type="text"
              v-model="book.price"
            >
          </td>
          <td v-else>{{book.price}}</td>

          <td v-if="editing === book.id">
            <button @click="editBook(book)">Save</button>
            <button
              class="muted-button"
              @click="cancelEdit(book)"
            >Cancel</button>
          </td>
          <td v-else>
            <button @click="editMode(book)">Edit</button>
            <!-- <button @click="$emit('delete:book', book.id)">Delete</button> -->
          </td>

        </tr>
      </tbody>
    </table>
  </div>
</template>

<script>
export default {
  props: {
    books: Array,
  },
  data() {
    return {
      editing: null,
    }
  },
  methods: {
    editMode(book) {
      this.cachedBook = Object.assign({}, book)
      this.editing = book.id
    },
    cancelEdit(book) {
      Object.assign(book, this.cachedBook)
      this.editing = null;
    },
    editBook(book) {
      if (book.name === '' || book.author === '' || book.price ==='') return
      this.$emit('edit:book', book.id, book)
      this.editing = null
    }
  }
}
</script>

<style scoped>
button {
  margin: 0 0.5rem 0 0;
}
input {
  margin: 0;
}
.empty-table {
  text-align: center;
}
</style>